<script setup lang="ts">
import { type Material } from "@/types/Material";
import { computed, nextTick, onMounted, ref, type Ref } from "vue";
import type { VForm } from "vuetify/components";

const initialMat: Material = {
    id: 0,
    name: "",
    QTY: 0,
    unit: "",
    min: 0,
};



const headers = [
    {
        title: 'Id',
        key: 'id',
        value: 'id'
    },
    {
        title: 'Name',
        key: 'name',
        value: 'name'
    },
    {
        title: 'QTY',
        key: 'QTY',
        value: 'QTY'
    },
    {
        title: 'Unit',
        key: 'unit',
        value: 'unit'
    }, {
        title: 'Min',
        key: 'min',
        value: 'min'
    },

    { title: 'Actions', key: 'actions', sortable: false }
    
]
const headers1 = [
    {
        title: 'Id',
        key: 'id',
        value: 'id'
    },
    {
        title: 'Name',
        key: 'name',
        value: 'name'
    },
    {
        title: 'QTY',
        key: 'QTY',
        value: 'QTY'
    },
    {
        title: 'Unit',
        key: 'unit',
        value: 'unit'
    }, {
        title: 'Min',
        key: 'min',
        value: 'min'
    }]
    const headers2 = [
    {
        title: 'Id',
        key: 'id',
        value: 'id'
    },
    {
        title: 'Name',
        key: 'name',
        value: 'name'
    },
    {
        title: 'QTY',
        key: 'QTY',
        value: 'QTY'
    },
    {
        title: 'Unit',
        key: 'unit',
        value: 'unit'

    },{ title: 'ADD', key: 'actions', sortable: false }
]
   
   

function closeDialog() {
    dialog.value = false
    nextTick(() => {
        editedMat.value = Object.assign({}, initialMat)
        editedIndex = -1
    })
}

async function save() {
    const { valid } = await refForm.value!.validate()
    if (!valid) return
    if (editedIndex > -1) {
        Object.assign(material.value[editedIndex], editedMat.value)
    } else {
        editedMat.value.id = lastId++
        material.value.push(editedMat.value)
    }
    editedIndex = -1
    closeDialog()
}
function closeDelete() {
    dialogDelete.value = false
    nextTick(() => {
        editedMat.value = Object.assign({}, initialMat)
    })
}

function deleteItemConfirm() {
    material.value.splice(editedIndex, 1)
    closeDelete()
}

function deleteItem(item: Material) {
    editedIndex = material.value.indexOf(item)
    editedMat.value = Object.assign({}, item)
    dialogDelete.value = true
    //editedIndex = -1
}
function editItem(item: Material) {
    editedIndex = material.value.indexOf(item)
    editedMat.value = Object.assign({}, item)
    dialog.value = true
}


const refForm = ref<VForm | null>(null)
let lastId = 4
let editedIndex = -1
const material = ref<Material[]>([])
const dialog2 = ref(false);
const dialog = ref(false)
const dialog1 = ref(false)
const form = ref(false)
const loading = ref(false)
const dialogDelete = ref(false)
function onSubmit() { }
const editedMat = ref<Material>(JSON.parse(JSON.stringify(initialMat)))

function initialize() {
    material.value = [{
        id: 1,
        name: 'น้ำตาล',
        QTY: 10,
        unit: 'กิโลกรัม',
        min: 3,
    }, {
        id: 2,
        name: 'น้ำเชื่อม',
        QTY: 10,
        unit: 'ลิตร',
        min: 3,
    }, {
        id: 3,
        name: 'เมล็ดกาแฟ',
        QTY: 20,
        unit: 'กิโลกรัม',
        min: 5,
    }, {
        id: 4,
        name: 'ผงชาเขียว',
        QTY: 2,
        unit: 'กิโลกรัม',
        min: 5,
    }, {
        id: 5,
        name: 'นมข้นหวาน',
        QTY: 2,
        unit: 'ลิตร',
        min: 5,
    }
        , {
        id: 6,
        name: 'ผงโกโก้',
        QTY: 1,
        unit: 'กิโลกรัม',
        min: 3,
    }
    ]

}

onMounted(() => {
    initialize()
})

function checkStock() {
    const lowStockItems = material.value.filter(item => item.QTY < item.min);
    console.log("Low Stock Items:", lowStockItems);

}
function addStock() {
    dialog2.value = true;
}

const filteredMaterial = computed(() => {
    return material.value.filter(item => item.QTY < item.min);
});

</script>

<template>
    <div>
        <v-data-table :headers="headers" :items="material">
            <template v-slot:top>
                <v-toolbar flat>
                    <v-toolbar-title>Material</v-toolbar-title>
                    <v-divider class="mx-4" inset vertical></v-divider>
                    
                    
                   
                        <v-dialog v-model="dialog1" fullscreen :scrim="false" transition="dialog-bottom-transition">
                            <template v-slot:activator="{ props }">
                                <v-btn color="red" dark v-bind="props">
                                    Check Stock
                                </v-btn>
                                
                            </template>
                            <v-card>
                                <v-toolbar dark color="primary">
                                    <v-btn icon dark @click="dialog1 = false">
                                        <v-icon>mdi-close</v-icon>
                                    </v-btn>
                                    <v-toolbar-title>CheckStock</v-toolbar-title>
                                    
                                    <v-toolbar-items>
                                        <v-btn variant="text" @click="dialog1 = false">
                                            Save
                                        </v-btn>
                                    </v-toolbar-items>
                                </v-toolbar>
                                <v-data-table :headers="headers1" :items="filteredMaterial"></v-data-table>

                            </v-card>
                        </v-dialog>
                    
                        <v-dialog
      v-model="dialog2"
      scrollable
      width="auto"
    >
      <template v-slot:activator="{ props }">
        <v-btn
          color='green'
          v-bind="props"
        >
          Add Stock
        </v-btn>
      </template>
      <v-card>
        <v-card-title>ADD-Stock</v-card-title>
        <v-divider></v-divider>
        <v-card-text style="height: 300px;">
            <v-data-table-virtual
    :headers="headers"
    :items="material"
    height="400"
    item-value="name"
  ><template v-slot:[`item.actions`]="{ item }">
                <v-icon size="small" class="me-2" @click="editItem(item)">
                    mdi-pencil
                </v-icon>
                </template>
</v-data-table-virtual>
        </v-card-text>
        <v-divider></v-divider>
        <v-card-actions>
            
          <v-btn
            color="blue-darken-1"
            variant="text"
            @click="dialog2 = false"
          >
            Close
          </v-btn>
          <v-btn
            color="blue-darken-1"
            variant="text"
            @click="dialog2 = false"
          >
            Save
          </v-btn>
        </v-card-actions>
      </v-card>
    </v-dialog>
                    

                    <v-dialog v-model="dialog" persistent width="1024">
                        <template v-slot:activator="{ props }">
                            <v-btn color="primary" v-bind="props">
                                New Material
                            </v-btn>
                        </template>
                        <v-card>
                            <v-card-title>
                                <span class="text-h5">ADD-Material</span>
                            </v-card-title>
                            <v-card-text>
                                <v-form ref="refForm" v-model="form" @submit.prevent="onSubmit">
                                    <v-container>
                                        <v-row>
                                            <v-col cols="12" sm="12" md="4">
                                                <v-text-field v-model="editedMat.name" :readonly="loading"
                                                    :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                                                    label="Name"></v-text-field>
                                            </v-col>
                                            <v-col cols="12" sm="12" md="4">
                                                <v-text-field v-model="editedMat.QTY" :readonly="loading"
                                                    :rules="[(v) => !!v || 'Field is required']" class="mb-2" clearable
                                                    label="QTY"></v-text-field>
                                            </v-col>

                                            <v-col cols="12" sm="6">
                                                <v-combobox label="Unit" :items="['กิโลกรัม', 'ลิตร']"
                                                    v-model="editedMat.unit"></v-combobox>
                                            </v-col>

                                            <v-col cols="12" sm="12" md="4">
                                                <v-text-field v-model="editedMat.min" :readonly="loading"
                                                    :rules="[(v) => !!v || 'Field is required']" clearable
                                                    label="Min"></v-text-field>
                                            </v-col>

                                        </v-row>

                                    </v-container>

                                </v-form>
                                <small>!โปรดตรวจสอบความถูกต้อง</small>
                            </v-card-text>
                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="blue-darken-1" variant="text" @click="closeDialog">Close</v-btn>
                                <v-btn color="blue-darken-1" variant="text" @click="save()">Save</v-btn>
                            </v-card-actions>
                        </v-card>
                    </v-dialog>

                    <!-- Delete Dialog -->
                    <v-dialog v-model="dialogDelete" max-width="500px">
                        <v-card>
                            <v-card-title class="text-h5">Are you sure you want to delete this item?</v-card-title>
                            <v-card-actions>
                                <v-spacer></v-spacer>
                                <v-btn color="blue-darken-1" variant="text" @click="closeDelete">Cancel</v-btn>
                                <v-btn color="blue-darken-1" variant="text" @click="deleteItemConfirm">OK</v-btn>
                                <v-spacer></v-spacer>
                            </v-card-actions>
                        </v-card>
                    </v-dialog>
                </v-toolbar>
            </template>
            <template v-slot:[`item.actions`]="{ item }">
                
                <v-icon color="red" size="small" @click="deleteItem(item)">
                    mdi-delete
                </v-icon>
            </template>
            <template v-slot:no-data>
                <v-btn color="primary" @click="initialize">
                    Reset
                </v-btn>
            </template>
        </v-data-table>
    </div>
</template>
  






 